attribute vec4 aPosition;
attribute vec2 aTextureCoord;
varying vec2 vTextureCoord;
varying vec2 blurCoord1s[14];
const highp float mWidth=720.0;
const highp float mHeight=1280.0;
uniform mat4 uMVPMatrix;
void main( )
{
    gl_Position = uMVPMatrix*aPosition;
    vTextureCoord = aTextureCoord;

    highp float mul_x = 2.0 / mWidth;
    highp float mul_y = 2.0 / mHeight;

    // 14个采样点
    blurCoord1s[0] = aTextureCoord + vec2( 0.0 * mul_x, -10.0 * mul_y );
    blurCoord1s[1] = aTextureCoord + vec2( 8.0 * mul_x, -5.0 * mul_y );
    blurCoord1s[2] = aTextureCoord + vec2( 8.0 * mul_x, 5.0 * mul_y );
    blurCoord1s[3] = aTextureCoord + vec2( 0.0 * mul_x, 10.0 * mul_y );
    blurCoord1s[4] = aTextureCoord + vec2( -8.0 * mul_x, 5.0 * mul_y );
    blurCoord1s[5] = aTextureCoord + vec2( -8.0 * mul_x, -5.0 * mul_y );
    blurCoord1s[6] = aTextureCoord + vec2( 0.0 * mul_x, -6.0 * mul_y );
    blurCoord1s[7] = aTextureCoord + vec2( -4.0 * mul_x, -4.0 * mul_y );
    blurCoord1s[8] = aTextureCoord + vec2( -6.0 * mul_x, 0.0 * mul_y );
    blurCoord1s[9] = aTextureCoord + vec2( -4.0 * mul_x, 4.0 * mul_y );
    blurCoord1s[10] = aTextureCoord + vec2( 0.0 * mul_x, 6.0 * mul_y );
    blurCoord1s[11] = aTextureCoord + vec2( 4.0 * mul_x, 4.0 * mul_y );
    blurCoord1s[12] = aTextureCoord + vec2( 6.0 * mul_x, 0.0 * mul_y );
    blurCoord1s[13] = aTextureCoord + vec2( 4.0 * mul_x, -4.0 * mul_y );
}