precision mediump float;
varying vec2 vTextureCoord;
uniform sampler2D uTexture;

void main() {
//    vec4 nColor = texture2D(uTexture, vTextureCoord);
//    gl_FragColor = vec4(1.0 - nColor.r, 1.0 - nColor.g, 1.0 - nColor.b, nColor.a);

    vec2 p = vTextureCoord - 0.5;

    // cartesian to polar coordinates
    float r = length(p);
    float a = atan(p.y, p.x);

    // distort
    //r = sqrt(r)*0.3; // pinch
    r = r*r * 3.0; // bulge

    // polar to cartesian coordinates
    p = r * vec2(cos(a)*0.5, sin(a)*0.5);

    // sample the iChannel0
    vec4 color = texture2D(uTexture, p + 0.5);
    gl_FragColor = color;
}