precision mediump float;
varying vec2 vTextureCoord;
uniform sampler2D uTexture;

uniform float uLandmarkX[69];
uniform float uLandmarkY[69];


vec2 getModifiedPoint(vec2 actualUV, vec2 pointUV, float radius, float strength){
	vec2 vecToPoint = pointUV - actualUV;
	float distToPoint = length(vecToPoint);

	float mag = (1.0 - (distToPoint / radius)) * strength;
	mag *= step(distToPoint, radius);

	return mag * vecToPoint;
}

void main() {
    vec2 uv = vTextureCoord;
    float radius = abs(uLandmarkY[37] - uLandmarkY[41]) * 2.0;
	float strength = 1.0;

	vec2 pos1 = vec2( ( uLandmarkX[36] + uLandmarkX[39] )*0.5, ( uLandmarkY[36] + uLandmarkY[39] )*0.5);
    vec2 pos2 = vec2( ( uLandmarkX[42] + uLandmarkX[45] )*0.5, ( uLandmarkY[42] + uLandmarkY[45] )*0.5);

    vec2 changePos =
        getModifiedPoint(uv, pos1, radius, strength) +
        getModifiedPoint(uv, pos2, radius, strength);

    gl_FragColor = texture2D(uTexture, uv + changePos);
}