precision mediump float;
varying vec2 vTextureCoord;
uniform sampler2D uTexture;

uniform float uLandmarkX[69];
uniform float uLandmarkY[69];


void main() {
    vec2 uv = vTextureCoord;
    vec4 camera = texture2D(uTexture, uv);

    float radius = 0.375 * abs((uLandmarkX[36]+uLandmarkX[39])*0.5 - (uLandmarkX[42]+uLandmarkX[45])*0.5);  // 0.2 ~ 0.4 -> 0.075 ~ 0.15
    vec2 scale = vec2(0.75, 1.5);

    vec2 center1 = vec2((uLandmarkX[36]+uLandmarkX[39])*0.5, (uLandmarkY[36]+uLandmarkY[39])*0.5);
    vec2 center2 = vec2((uLandmarkX[42]+uLandmarkX[45])*0.5, (uLandmarkY[42]+uLandmarkY[45])*0.5);

    float dist1 = length(scale * (uv - center1));
    float dist2 = length(scale * (uv - center2));

    vec4 flush = vec4(0.0, 0.0, 0.0, 1.0);

    vec4 tmp = mix(flush, camera, smoothstep(0.0, 1.0, dist1/radius));
    gl_FragColor = mix(flush, tmp, smoothstep(0.0, 1.0, dist2/radius));
}